#include "control.h"
#include "rf297L.h"
#include "key_scan.h"
#include "delay.h"



unsigned char RF_STATE=RF_MATCH_TX;

void RF_CONTROL_WORK(void)
{
	
	const control_id[4]={0x11,0x22,0x33,0x44};
	const unsigned char TX_ADDRESS[4] = {0xCC,0xCC,0xCC,0xCC};
	const unsigned char frequency[4]={20,40,55,65};
	unsigned char rf_buf[12];
	static unsigned char frequency_num=0;
	static unsigned char Match_id[4];
	static unsigned char time_count=0;
	unsigned char count=0;
	unsigned char key_value;
	unsigned char crc=0;
	static unsigned char test_msg=0;
	
	switch(RF_STATE)
	{
		case RF_MATCH_TX:
				{
					rf_buf[0]=0x55;rf_buf[1]=0x20;
					rf_buf[2]=control_id[0];rf_buf[3]=control_id[1];rf_buf[4]=control_id[2];rf_buf[5]=control_id[3];
					rf_buf[6]=0;rf_buf[7]=0;rf_buf[8]=0;rf_buf[9]=0;			
					rf_buf[10]=0;
					rf_buf[11]=rf_buf[0]+rf_buf[1]+rf_buf[2]+rf_buf[3]+rf_buf[4]+rf_buf[5]+rf_buf[6]+rf_buf[7]+rf_buf[8]+rf_buf[9]+rf_buf[10];
					RF_TxData(rf_buf,PAYLOAD_WIDTH);
					soft_delay_ms(2);
					RF_TxData(rf_buf,PAYLOAD_WIDTH);
					RF_STATE=RF_MATCH_RX;
					RF_RX_MODE();
				}break;
		case RF_MATCH_RX:
				{
					if(RF_Read_RxData(rf_buf,PAYLOAD_WIDTH))
						{
							crc=rf_buf[0]+rf_buf[1]+rf_buf[2]+rf_buf[3]+rf_buf[4]+rf_buf[5]+rf_buf[6]+rf_buf[7]+rf_buf[8]+rf_buf[9]+rf_buf[10];
							if(crc==rf_buf[11])
							{
								if(rf_buf[2]==control_id[0]&&rf_buf[3]==control_id[1]&&rf_buf[4]==control_id[2]&&rf_buf[5]==control_id[3])
								{
									Match_id[0]=rf_buf[6];
									Match_id[1]=rf_buf[7];
									Match_id[2]=rf_buf[8];
									Match_id[3]=rf_buf[9];

									if(rf_buf[1]==0xa1)
										{
										//
											RF_STATE=RF_TX_DATA;
										//	RF_Write_Buff(W_REGISTER + TX_ADDR, control_id, sizeof(control_id));
											RF_Write_Buff(W_REGISTER + RX_ADDR_P1,control_id, sizeof(control_id));
											RF_TX_MODE();
										}
									else if(rf_buf[1]==0xa0)
										{
											RF_STATE=RF_MATCH_ACK;
											RF_TX_MODE();
										}
								}
							}
						}
					else
						{
						soft_delay_ms(1);
						time_count++;
						if(time_count>=80)
							{
								time_count=0;
								RF_STATE=RF_MATCH_TX;
								RF_TX_MODE();
							}
						}
					
					}break;
		case RF_MATCH_ACK:
				{
					rf_buf[0]=0x55;rf_buf[1]=0x21;
					rf_buf[2]=control_id[0];rf_buf[3]=control_id[1];rf_buf[4]=control_id[2];rf_buf[5]=control_id[3];
					rf_buf[6]=Match_id[0];rf_buf[7]=Match_id[1];rf_buf[8]=Match_id[2];rf_buf[9]=Match_id[3];			
					rf_buf[10]=0;
					rf_buf[11]=rf_buf[0]+rf_buf[1]+rf_buf[2]+rf_buf[3]+rf_buf[4]+rf_buf[5]+rf_buf[6]+rf_buf[7]+rf_buf[8]+rf_buf[9]+rf_buf[10];
					for(count=0;count<50;count++)
						{
							RF_TxData(rf_buf,PAYLOAD_WIDTH);
						}
					RF_Write_Buff(W_REGISTER + RX_ADDR_P1,control_id, sizeof(control_id));
					RF_STATE=RF_TX_DATA;
				}break;
		case RF_TX_DATA:
				{
				
					key_value=key_scan();		
					if(key_value)
						{
							//send_data
							rf_buf[2]=control_id[0];rf_buf[3]=control_id[1];rf_buf[4]=control_id[2];rf_buf[5]=control_id[3];
							rf_buf[6]=Match_id[0];rf_buf[7]=Match_id[1];rf_buf[8]=Match_id[2];rf_buf[9]=Match_id[3];	
							rf_buf[10]=key_value;
							for(count=0;count<4;count++)
								{
									RF_set_channel(frequency[count]);
								if(count!=3)
									{
									rf_buf[0]=0xaa;rf_buf[1]=0x30;
									RF_Write_Buff(W_REGISTER + TX_ADDR, control_id, sizeof(control_id));
									}
								else
									{
									rf_buf[0]=0x50;rf_buf[1]=0x40;
									RF_Write_Buff(W_REGISTER + TX_ADDR, TX_ADDRESS, sizeof(TX_ADDRESS));
									}
									rf_buf[11]=rf_buf[0]+rf_buf[1]+rf_buf[2]+rf_buf[3]+rf_buf[4]+rf_buf[5]+rf_buf[6]+rf_buf[7]+rf_buf[8]+rf_buf[9]+rf_buf[10];
									
									RF_Write_Buff(W_TX_PAYLOAD, rf_buf, PAYLOAD_WIDTH);                               		//write data to txfifo                                                                      		//rf entery tx mode start send data                                                                       		//rf entery stb3
    									soft_delay_ms(2);//2
    									RF_WriteReg(REUSE_TX_PL,0);
									soft_delay_ms(7);
									RF_ClearFIFO();
									RF_ClearStatus();
								}
							
						}

				}break;
	}

}








