#include "cms.h"
#include "virtual_timer.h"
#include "timer1.h"
#include "key_scan.h"
#include "control.h"
#include "system.h"

static volatile unsigned int Timer1_set_time;

void Timer1_Init(TIMER1_DIVIDER_e TIMER1_DIVIDER);
void Timer1_start(unsigned int T_nums, unsigned char Timer1_ISR_execution_total_time);
void Timer1_stop(void);
void TIMER1_ISR(void);

/**************************************************************************
*ʱԴΪF = Fosc
*Сʱʱ T = (1/F)*TIMER1_DIVIDER
**************************************************************************/
void Timer1_Init(TIMER1_DIVIDER_e TIMER1_DIVIDER)
{
	T1CON = 0x00;	//TMR1GE = 0,Timer1TMR1ON	TMR1CS = 0;ѡڲʱFOSC
	T1CON |= TIMER1_DIVIDER;	//Ƶ	Bit5 Bit4 
	INTCON |= (0x40);	//PEIE = 1;		δεⲿж
	PIE1 |= 0x01;		//TMR1IE = 1;	TMR1ж
}

/*************************************************************************************
*ʵʱ붨ʱʱƫ,ͨTimer1_ISR_execution_total_time
*Timer1_ISR_execution_total_time == Timer1жϲжϺ˳жϺִʱ䣩/TIMER1_DIVIDER,
*ʱʱ == T_nums * T
*T = (1/F)*TIMER1_DIVIDER
*************************************************************************************/
void Timer1_start(unsigned int T_nums, unsigned char Timer1_ISR_execution_total_time)
{
	Timer1_set_time = 0xffff - T_nums + Timer1_ISR_execution_total_time;
	TMR1L = (unsigned char)(Timer1_set_time);
	TMR1H = (unsigned char)(Timer1_set_time>>8);
	PIR1 &= ~(0x01);	// TMR1IF = 0;	
	T1CON |= 0x01;		// TMR1ON = 1;	Start Timer0
}


void Timer1_stop(void)
{
	PIE1 &= ~(0x01);		//TMR1IE = 0;	TMR1ж
	T1CON &= ~(0x01);	//TMR1ON = 0;	ضʱ
}
extern unsigned char flag_weekup;
volatile unsigned int flag_sleep_add=0;
extern unsigned char RF_STATE;
extern unsigned char key_check;
void TIMER1_ISR(void)
{
	static unsigned char led_sta=0;
	T1CON &= ~(0x01);	//TMR1ON = 0;	ضʱ
	TMR1L = (unsigned char)(Timer1_set_time);
	TMR1H = (unsigned char)(Timer1_set_time>>8);
	//Do something
	led_sta++;
	if(led_sta>=30)
		{
		led_sta=0;
		if(RF_STATE!=RF_TX_DATA)
			{
				PORTC^=1<<0;
			}
		else
			{
			if(key_check==0)LED_OFF;
			}
		}
	flag_sleep_add++;
	if(flag_sleep_add>=6000)
	{
		flag_sleep_add=0;
		flag_weekup=0;
	}
	///////////////////////////////////////////////////
	PIR1 &= ~(0x01);	// TMR1IF = 0;	
	T1CON |= 0x01;		//TMR1ON = 1;		ʱ
}
