#include "cms.h"
#include "virtual_timer.h"
#include "timer1.h"
#include "key_scan.h"
#include "rf297L.h"
#include "remote.h"

static volatile unsigned int Timer1_set_time;

void Timer1_Init(TIMER1_DIVIDER_e TIMER1_DIVIDER);
void Timer1_start(unsigned int T_nums, unsigned char Timer1_ISR_execution_total_time);
void Timer1_stop(void);
void TIMER1_ISR(void);

/**************************************************************************
*ʱԴΪF = Fosc
*Сʱʱ T = (1/F)*TIMER1_DIVIDER
**************************************************************************/
void Timer1_Init(TIMER1_DIVIDER_e TIMER1_DIVIDER)
{
	T1CON = 0x00;	//TMR1GE = 0,Timer1TMR1ON	TMR1CS = 0;ѡڲʱFOSC
	T1CON |= TIMER1_DIVIDER;	//Ƶ	Bit5 Bit4 
	INTCON |= (0x40);	//PEIE = 1;		δεⲿж
	PIE1 |= 0x01;		//TMR1IE = 1;	TMR1ж
}

/*************************************************************************************
*ʵʱ붨ʱʱƫ,ͨTimer1_ISR_execution_total_time
*Timer1_ISR_execution_total_time == Timer1жϲжϺ˳жϺִʱ䣩/TIMER1_DIVIDER,
*ʱʱ == T_nums * T
*T = (1/F)*TIMER1_DIVIDER
*************************************************************************************/
void Timer1_start(unsigned int T_nums, unsigned char Timer1_ISR_execution_total_time)
{
	Timer1_set_time = 0xffff - T_nums + Timer1_ISR_execution_total_time;
	TMR1L = (unsigned char)(Timer1_set_time);
	TMR1H = (unsigned char)(Timer1_set_time>>8);
	PIR1 &= ~(0x01);	// TMR1IF = 0;	
	T1CON |= 0x01;		// TMR1ON = 1;	Start Timer0
}


void Timer1_stop(void)
{
	PIE1 &= ~(0x01);		//TMR1IE = 0;	TMR1ж
	T1CON &= ~(0x01);	//TMR1ON = 0;	ضʱ
	PIR1 &= ~(0x01);	// TMR1IF = 0;	
}
extern unsigned char cmd;





const unsigned char FORWORD[7]={0xee,0xee,0xaa,0xaa,0xae,0xee,0xea};
const unsigned char RE_FORWORD[15]={0xee,0xee,0xaa,0xaa,0xaa,0xaa,0xaa,0xaa,0xaa,0xaa,0xaa,0xaa,0xee,0xee,0xa0};
const unsigned char RIGHT[21]={0xee,0xee,0xaa,0xaa,0xaa,0xaa,0xaa,0xaa,0xaa,0xaa,0xaa,0xaa,0xaa,0xaa,0xaa,0xaa,0xaa,0xaa,0xee,0xee,0xa0};
const unsigned char LEFT[19]={0xee,0xee,0xaa,0xaa,0xaa,0xaa,0xaa,0xaa,0xaa,0xaa,0xaa,0xaa,0xaa,0xaa,0xaa,0xaa,0xae,0xee,0xea};
const unsigned char FORWORD_RIGHT[13]={0xee,0xee,0xaa,0xaa,0xaa,0xaa,0xaa,0xaa,0xaa,0xaa,0xae,0xee,0xea};
const unsigned char RE_FORWORD_RIGHT[16]={0xee,0xee,0xaa,0xaa,0xaa,0xaa,0xaa,0xaa,0xaa,0xaa,0xaa,0xaa,0xaa,0xae,0xee,0xea};
const unsigned char FORWORD_LIFT[12]={0xee,0xee,0xaa,0xaa,0xaa,0xaa,0xaa,0xaa,0xaa,0xee,0xee,0xa0};
const unsigned char RE_FORWORD_LIFT[18]={0xee,0xee,0xaa,0xaa,0xaa,0xaa,0xaa,0xaa,0xaa,0xaa,0xaa,0xaa,0xaa,0xaa,0xaa,0xee,0xee,0xa0};

extern unsigned char RF_STATE;
extern unsigned char motor_state;
extern unsigned char flag_weekup;


void TIMER1_ISR(void)
{
	
	static unsigned char led_sta=0,led_sta1=0;

	static unsigned char flag_motor=0;
	static unsigned char i=0,j=0,k=0x80;
	static unsigned int flag_motor_add=0;
	T1CON &= ~(0x01);	//TMR1ON = 0;	ضʱ
	TMR1L = (unsigned char)(Timer1_set_time);
	TMR1H = (unsigned char)(Timer1_set_time>>8);
	//Do something
//	key_scan();
//	virtual_timer_pro();

	if((cmd!=0)&&(flag_motor==0))
	{
		switch (cmd)
		{
			case 0x01:i=7;break;
			case 0x02:i=15;break;
			case 0x20:i=19;break;
			case 0x10:i=21;break;
			case 0x21:i=12;break;
			case 0x11:i=13;break;
			case 0x22:i=18;break;
			case 0x12:i=16;break;
		}
		flag_motor=1;
	}
	
	if((flag_motor==0)&&(motor_state!=CAR_STOP))
		{
		flag_motor_add++;
		if(flag_motor_add>1000)
			{
			motor_state=CAR_STOP;
			}
		}
	else
		{
		flag_motor_add=0;
		}			/*
				case 0x01:FORWORD();break;
				case 0x02:RE_FORWORD();break;
				case 0x20:left();break;
				case 0x10:right();break;
				case 0x21:FORWORD_left();break;
				case 0x11:FORWORD_light();break;
				case 0x22:RE_FORWORD_left();break;
				case 0x12:RE_FORWORD_light();break;
				*/
	
	if(flag_motor)
		{
		switch(i)
			{
			case 7:
					{
						if(FORWORD[j]&k)
							{
							PORTB|=1<<3;
							}
						else
							{
							PORTB&=~(1<<3);
							}
						if(k!=0x01)
							k>>=1;
						else
							{
								k=0x80;
								if(j<(i-1))j++;
								else
									{
									j=0;
									flag_motor=0;
									cmd=0;
									}
							}
						}break;
			case 15:
					{
						if(RE_FORWORD[j]&k)
							{
							PORTB|=1<<3;
							}
						else
							{
							PORTB&=~(1<<3);
							}
						if(k!=0x01)
							k>>=1;
						else
							{
								k=0x80;
								if(j<(i-1))j++;
								else
									{
									j=0;
									flag_motor=0;
									cmd=0;
									}
							}
						}break;
			case 19:
					{
						if(LEFT[j]&k)
							{
							PORTB|=1<<3;
							}
						else
							{
							PORTB&=~(1<<3);
							}
						if(k!=0x01)
							k>>=1;
						else
							{
								k=0x80;
								if(j<(i-1))j++;
								else
									{
									j=0;
									flag_motor=0;
									cmd=0;
									}
							}
						}break;
			case 21:
					{
						if(RIGHT[j]&k)
							{
							PORTB|=1<<3;
							}
						else
							{
							PORTB&=~(1<<3);
							}
						if(k!=0x01)
							k>>=1;
						else
							{
								k=0x80;
								if(j<(i-1))j++;
								else
									{
									j=0;
									flag_motor=0;
									cmd=0;
									}
							}
						}break;
			case 12:
					{
						if(FORWORD_LIFT[j]&k)
							{
							PORTB|=1<<3;
							}
						else
							{
							PORTB&=~(1<<3);
							}
						if(k!=0x01)
							k>>=1;
						else
							{
								k=0x80;
								if(j<(i-1))j++;
								else
									{
									j=0;
									flag_motor=0;
									cmd=0;
									}
							}
						}break;
			case 13:
					{
						if(FORWORD_RIGHT[j]&k)
							{
							PORTB|=1<<3;
							}
						else
							{
							PORTB&=~(1<<3);
							}
						if(k!=0x01)
							k>>=1;
						else
							{
								k=0x80;
								if(j<(i-1))j++;
								else
									{
									j=0;
									flag_motor=0;
									cmd=0;
									}
							}
						}break;
			case 18:
					{
						if(RE_FORWORD_LIFT[j]&k)
							{
							PORTB|=1<<3;
							}
						else
							{
							PORTB&=~(1<<3);
							}
						if(k!=0x01)
							k>>=1;
						else
							{
								k=0x80;
								if(j<(i-1))j++;
								else
									{
									j=0;
									flag_motor=0;
									cmd=0;
									}
							}
						}break;
			case 16:
					{
						if(RE_FORWORD_RIGHT[j]&k)
							{
							PORTB|=1<<3;
							}
						else
							{
							PORTB&=~(1<<3);
							}
						if(k!=0x01)
							k>>=1;
						else
							{
								k=0x80;
								if(j<(i-1))j++;
								else
									{
									j=0;
									flag_motor=0;
									cmd=0;
									}
							}
						}break;
			}
		}
	

	if(RF_STATE!=RF_RX_DATA)
	{
		led_sta++;
		if(led_sta>200)
		{
			led_sta=0;
			led_sta1++;
		}
		if(led_sta1>3)
		{
			led_sta1=0;
			PORTB^=1<<1;
		}
	}
	else
	{
		if(motor_state!=CAR_STOP)
			{
					PORTB|=1<<1;
			}
		else
			{
				PORTB&=~(1<<1);
			}
	}
	///////////////////////////////////////////////////
	PIR1 &= ~(0x01);	// TMR1IF = 0;	
	T1CON |= 0x01;		//TMR1ON = 1;		ʱ
}
